function G = tomo2d(sw);
% TomKrnl generate the design matrix (kernl)
% Input:
%       sw = [0/1] to generate [1] diagonal scans.
% of the tomography problem

if(sw > 2 | sw < 0); sw=1;end;
if (sw == 1)
    G=zeros(22,16);
else;
    G=zeros(8,16);
end;

% Row-Scans
for i=1:4,
    for j=1:4,
    G(i,ij2ndx(i,j,4))=1.0;
    end;
end;

% Column-Scans
for i=1:4,
    for j=1:4,
    G(i+4,ij2ndx(j,i,4))=1.0;
    end;
end;
% Put a ray through the NE-SW cross diagonal.
if (sw == 1);
for k=3:-1:-3;
    for l=max(1,1-k):min(4,4-k),
        G(12-k,ij2ndx(l,5-(l+k),4))=sqrt(2);
    end;
end;
%
% Put a ray through the NW-SE cross diagonal.
for k=-3:3;
    for l=max(1,1-k):min(4,4-k),
        G(19+k,ij2ndx(l+k,l,4))=sqrt(2);
    end;
end;
end;
% end
% cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function ndx=ij2ndx(i,j,NC)
% k=ijtoind(i,j,NC)
% Maps i,j coordinates in an array into a one dimensional vector
% coordinate.
%
ndx=j+(i-1)*NC;
% cccccccccccccccccccccccc   End   ccccccccccccccccccccccccccc